Imports UvARescue.Math
Imports System.Math

Public Class ActuatorStatus
    Inherits SingleStateSensor(Of ActuatorStatusData)

    Public Shared ReadOnly SENSORTYPE_ACTUATORSTATUS As String = "ActuatorStatus"

    Private _OffsetX As Double
    Private _OffsetY As Double
    Private _OffsetTheta As Double

    Public Sub New()
        Me.New(Sensor.MATCH_ANYNAME)
    End Sub
    Public Sub New(ByVal name As String)

        MyBase.New(New ActuatorStatusData, SENSORTYPE_ACTUATORSTATUS, name)

    End Sub

    Protected Overrides Sub ProcessMessage(ByVal msgtype As MessageType, ByVal msg As System.Collections.Specialized.StringDictionary)
        MyBase.ProcessMessage(msgtype, msg)

        If msgtype = MessageType.MissionPackageStatus Then

            If Me.SensorName <> msg("Name") Then
                Console.WriteLine(String.Format("{0} received ProcessMessage for ActuatorChain with name {1}", Me.SensorName, msg("Name")))
            End If
            Me.CurrentData.Load(msg)

            Me.Agent.NotifySensorUpdate(Me)
            'Me.ProcessEncoderData(Me.CurrentData) previously called by Agent
        End If

        msg.Clear()
        msg = Nothing

    End Sub

    Public Sub DefaultGeometry(ByVal robotModel As String)


        ' he GetGEO message is not directly loaded. To avoid access to empty dictionary, load the default values

        If IsNothing(robotModel) Then
            Console.WriteLine("[ActuatorStatus]: No RobotModel")
            'Do not load wrong model, because the correct number of front and rear sonars are important
        Else
            If robotModel.ToLower.StartsWith("airrobot") Then

                'configuration between link 0 and link 1

                Console.WriteLine("[ActuatorStatus]: Give location and orientation between link 1 and 0 of AirRobot")

                '_X = Single.Parse(locations(0))
                '_Y = Single.Parse(locations(1))
                '_Z = Single.Parse(locations(2))

                '_Roll = Single.Parse(orientations(0))
                '_Pitch = Single.Parse(orientations(1))
                '_Yaw = Single.Parse(orientations(2))

            Else

                Console.WriteLine("[ActuatorStatus]: Unknown RobotModel")

                'Do not load wrong model, because the correct number of front and rear sonars are important
            End If
        End If

        'Values can be later overwritten, when a GetGEO message arrives

    End Sub



End Class
