
'SEN {Type IMU} {Name string} {Orientation r,p,y} {AngularVel r,p,y} {AngularAccel r,p,y} {XYZAcceleration x,y,z}
' units radians, radians/sec, radians/sec^2, m/s^2

'For UDK AirRobot
'msg = "SEN {Time 1613.4530} {Type IMU} {Name IMU} {XYZAcceleration -0.0000,0.0000,-0.0000} {AngularVel -0.0054,2.6284,-4.3821} {AngularAccel -0.0286,13.6975,9.9067} {Rotation -0.0010,-0.0002,0.0004}"

<Serializable()> _
Public Class ImuData
    Implements ISensorData

    Public Sub New()
        Me._Roll = 0
        Me._Pitch = 0
        Me._Yaw = 0
        Me._RollVel = 0
        Me._PitchVel = 0
        Me._YawVel = 0
    End Sub

    Public Sub Load(ByVal msg As System.Collections.Specialized.StringDictionary) Implements ISensorData.Load

        Dim parts() As String
        If msg.ContainsKey("Orientation") Then
            parts = Strings.Split(msg("Orientation"), ",")
            If Not IsNothing(parts(0)) AndAlso Not parts(0).StartsWith("--") Then 'Division by zero
                Me._Roll = Double.Parse(parts(0))
                Me._Pitch = Double.Parse(parts(1))
                Me._Yaw = Double.Parse(parts(2))
            End If

        End If

        If msg.ContainsKey("Rotation") Then
            parts = Strings.Split(msg("Rotation"), ",")
            Me._Roll = Double.Parse(parts(0))
            Me._Pitch = Double.Parse(parts(1))
            Me._Yaw = Double.Parse(parts(2))
        End If

        If msg.ContainsKey("AngularVel") Then
            parts = Strings.Split(msg("AngularVel"), ",")
            If Not IsNothing(parts(0)) AndAlso Not parts(0).StartsWith("--") AndAlso Not parts(0).StartsWith("-2147483648.-21") Then 'Division by zero
                Me._RollVel = Double.Parse(parts(0))
                Me._PitchVel = Double.Parse(parts(1))
                Me._YawVel = Double.Parse(parts(2))
            End If

        End If

        If msg.ContainsKey("AngularAccel") Then

        End If

        If msg.ContainsKey("XYZAcceleration") Then

        End If
    End Sub

    Private _Roll As Double
    Public ReadOnly Property Roll() As Double
        Get
            Return _Roll
        End Get
    End Property

    Private _Pitch As Double
    Public ReadOnly Property Pitch() As Double
        Get
            Return _Pitch
        End Get
    End Property

    Private _Yaw As Double
    Public ReadOnly Property Yaw() As Double
        Get
            Return _Yaw
        End Get
    End Property

    Private _RollVel As Double
    Public ReadOnly Property RollVel() As Double
        Get
            Return _RollVel
        End Get
    End Property

    Private _PitchVel As Double
    Public ReadOnly Property PitchVel() As Double
        Get
            Return _PitchVel
        End Get
    End Property

    Private _YawVel As Double
    Public ReadOnly Property YawVel() As Double
        Get
            Return _YawVel
        End Get
    End Property
End Class
