Imports UvARescue.Math

Public Class ImuSensor
    Inherits SingleStateSensor(Of ImuData)

    Public Shared ReadOnly SENSORTYPE_IMU As String = "IMU"

    Public Sub New()
        MyBase.New(New ImuData, SENSORTYPE_IMU, Sensor.MATCH_ANYNAME)
    End Sub

    Protected Overrides Sub ProcessMessage(ByVal msgtype As MessageType, ByVal msg As System.Collections.Specialized.StringDictionary)
        MyBase.ProcessMessage(msgtype, msg)

        If msgtype = MessageType.Sensor Then
            Me.CurrentData.Load(msg)

            '_CurrentPose.X = Me.CurrentData.X()
            '_CurrentPose.Y = Me.CurrentData.Y()
            '_CurrentPose.Z = Me.CurrentData.Z()

            ' _CurrentPose.Roll = Me.CurrentData.Roll() 'Fails on Currentdata (singleStateSensor called with wrong arguments!?).
            ' _CurrentPose.Pitch = Me.CurrentData.Pitch()
            ' _CurrentPose.Yaw = Me.CurrentData.Yaw()

            'Me.Agent.NotifySensorUpdate(Me)
        End If

        msg.Clear()
        msg = Nothing

    End Sub

    Private _CurrentPose As Pose3D
    Public ReadOnly Property PoseEstimate() As Pose3D
        Get
            Return _CurrentPose
        End Get
        'The x,y,z accelleration should be aggregated into x,y,z velocity, which should be added to the current offset.
    End Property
End Class
